int cellSize = 5; //<>//
int[][] allCells;
int[][] futureCells;
int rowMax, colMax;
boolean active = false;


void setup() {
  fullScreen();
  frameRate(10);
  background(0);
  stroke(0);
  strokeWeight(2);
  rowMax = height/cellSize;
  colMax = width/cellSize;
  allCells = new int[rowMax][colMax];
  futureCells = new int[rowMax][colMax];
  initCells();
}

void draw() {
  background(0);
  for (int y=1; y<rowMax-1; y++) {
    for (int x=1; x<colMax-1; x++) {
      if (allCells[y][x]==0) {
        fill(0);
      } else {
        fill(255);
      }
      rect(x*cellSize, y*cellSize, cellSize, cellSize);
    }
  }
  if (active) {
    updateCells();
  }
}

void keyReleased() {
  active = !active;
}

void mouseDragged() {
  if (!active) {
    int posY = mouseY/cellSize;
    int posX = mouseX/cellSize;
    int radius = 2;
    for (int y=-radius; y<=radius; y++) {
      for (int x=-radius; x<radius; x++) {
        if (posY+y>=0 && posY+y<rowMax && posX+x>=0 && posX+x<colMax) {
          allCells[posY+y][posX+x] = 1;
        }
      }
    }
  }
}


void initCells() {
  for (int y=1; y<rowMax-1; y++) {
    for (int x=1; x<colMax-1; x++) {
      if (random(20)>17) {
        allCells[y][x] = 1;
      }
    }
  }
  
}

void printCells() {
  println("--------");
  for (int y=0; y<rowMax; y++) {
    for (int x=0; x<colMax; x++) {
      print(allCells[y][x]+" ");
    }
    println();
  }
  println("--------");
}

void updateCells() {
  //2D-Array leeren
  futureCells = new int[rowMax][colMax];
  //Berechnen
  int aktuellerStatus = -1;
  for (int y=1; y<rowMax-1; y++) {
    for (int x=1; x<colMax-1; x++) {
      aktuellerStatus = getStatus(y, x);
      if (allCells[y][x]==1) {
        if (aktuellerStatus<2 || aktuellerStatus>3) {
          //zu wenige oder zu viele -> Tod
          futureCells[y][x] = 0;
        } else {
          futureCells[y][x] = 1;
        }
      } else {
        //Zelle ist tot
        if (aktuellerStatus==3) {
          futureCells[y][x] = 1;
        }
      }
    }
  }
  
  //Zellen kopieren
  for (int i=0; i<allCells.length; i++) {
    for (int j=0; j<allCells[i].length; j++) {
      allCells[i][j]=futureCells[i][j];
    }
  }
}

int getStatus(int x, int y) {
  return allCells[x-1][y-1]+allCells[x][y-1]+allCells[x+1][y-1]+allCells[x-1][y]+allCells[x+1][y]+allCells[x-1][y+1]+allCells[x][y+1]+allCells[x+1][y+1];
}
